﻿using System;
using System.Collections;

namespace EventSubscriber {
    internal class Product {
        public string ProductName { get; set; }
        public int Price { get; set; }
    }
    public class EventHandlerArgs : EventArgs {
        private Product prod;
        internal EventHandlerArgs(Product newProduct) {
            prod = newProduct;
        }
        internal Product Prod {
            get { return prod; }
        }
    }

    public delegate void OnChangeDel(object sender, EventArgs a);
    
    public class ListWithEvents : ArrayList {

        public event OnChangeDel change;
        protected virtual void OnChanged(EventArgs e) {
            if (change != null) {
                change(this, e);
            } else {
                Console.WriteLine("No one is listening... :-(");
            }
            // TODO trigger the event, print a Console message if no subscribers exist
        }
        public override int Add(Object product) {
            int added = base.Add(product);
            // TODO call OnChanged indicating a product was added
            OnChanged(new EventHandlerArgs((Product) product));
            return added;
        }
        public override void Clear() {
            base.Clear();
            // TODO call OnChanged indicating no product was added
            OnChanged(null);
        }
        public override object this[int index] {
            set {
                base[index] = value;
                // TODO call OnChanged indicating no product was added
                OnChanged(null);
            }
        }
    }
    public class Subscriber {
        private ListWithEvents specialList;
        public Subscriber(ListWithEvents publisher) {
            this.specialList = publisher;
            publisher.change += publishers_ProdcutAddedInfo;
            // TODO subscribe the event
        }
        void publishers_ProdcutAddedInfo(object sender, EventArgs e) {
            // TODO define arguments for when a product is added
            if (e == null) {
                Console.WriteLine("No New Product Added.");
                return;
            }
            Console.WriteLine("A New Product Added.");
        }
        public void UnSubscribeEvent() {
            specialList.change -= publishers_ProdcutAddedInfo;
        }
    }
    class Program {
        static void Main(string[] args) {
            ListWithEvents publisher = new ListWithEvents();
            Subscriber subscriber = new Subscriber(publisher);
            publisher.Add(new Product
            {
                ProductName = "Complan",
                Price = 20
            });
            publisher.Add(new Product
            {
                ProductName = "Horlics",
                Price = 120
            });
            publisher.Clear();
            subscriber.UnSubscribeEvent();
            publisher.Add(new Product
            {
                ProductName = "Boost",
                Price = 200
            });
            Console.ReadKey();
        }
    }


}
